MPQC 2.3.1

- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
sc::RefSCVector Class Reference

The RefSCVector class is a smart pointer to an SCVector specialization. More...

`#include <matrix.h>`

Inheritance diagram for sc::RefSCVector:
[legend]
Collaboration diagram for sc::RefSCVector:
[legend]

## Public Member Functions
| RefSCVector ()
| Initializes the vector pointer to 0. More...
| RefSCVector (const RefSCVector &v)
| Make this and v refer to the same SCVector.
| RefSCVector (SCVector *v)
| Make this refer to v.
RefSCVector & | operator= (SCVector *v)
| Make this refer to v.
RefSCVector & | operator= (const RefSCVector &v)
| Make this and v refer to the same SCVector.
| RefSCVector (const RefSCDimension &dim, const Ref< SCMatrixKit > &)
| Create a vector with dimension dim. More...
SCVectordouble | operator() (int) const
| Return an l-value that can be used to assign or retrieve an element.
SCVectordouble | operator[] (int) const
| Return an l-value that can be used to assign or retrieve an element.
RefSCVector | operator+ (const RefSCVector &a) const
| Add two vectors.
RefSCVector | operator- (const RefSCVector &a) const
| Subtract two vectors.
RefSCVector | operator* (double) const
| Scale a vector.
RefSCMatrix | outer_product (const RefSCVector &v) const
| Return the outer product between this and v.
RefSymmSCMatrix | symmetric_outer_product () const
| The outer product of this with itself is a symmetric matrix.
void | set_element (int i, double val) const
void | accumulate_element (int i, double val) const
double | get_element (int) const
int | n () const
RefSCDimension | dim () const
Ref< SCMatrixKit > | kit () const
RefSCVector | clone () const
RefSCVector | copy () const
double | maxabs () const
double | scalar_product (const RefSCVector &) const
double | dot (const RefSCVector &) const
void | normalize () const
void | randomize () const
void | assign (const RefSCVector &v) const
void | assign (double val) const
void | assign (const double *v) const
void | convert (double *) const
void | scale (double val) const
void | accumulate (const RefSCVector &v) const
void | accumulate_product (const RefSymmSCMatrix &, const RefSCVector &)
void | accumulate_product (const RefSCMatrix &, const RefSCVector &)
void | element_op (const Ref< SCElementOp > &op) const
void | element_op (const Ref< SCElementOp2 > &, const RefSCVector &) const
void | element_op (const Ref< SCElementOp3 > &, const RefSCVector &, const RefSCVector &) const
void | print (std::ostream &out) const
void | print (const char *title=0, std::ostream &out=ExEnv::out0(), int precision=10) const
void | save (StateOut &)
void | restore (StateIn &)
| Restores the matrix from StateIn object. The vector must have been initialized already.
Public Member Functions inherited from sc::Ref< SCVector >
| Ref ()
| Create a reference to a null object.
| Ref (SCVector *a)
| Create a reference to the object a.
| Ref (const Ref< SCVector > &a)
| Create a reference to the object referred to by a.
| Ref (const Ref< A > &a)
| Create a reference to the object referred to by a.
| ~Ref ()
| Create a reference to the object a. More...
SCVector * | operator-> () const
| Returns the reference counted object. More...
SCVector * | pointer () const
| Returns a pointer the reference counted object.
RefCount * | parentpointer () const
| Implements the parentpointer pure virtual in the base class.
| operator SCVector * () const
SCVector & | operator* () const
| Returns a C++ reference to the reference counted object. More...
int | null () const
| Return 1 if this is a reference to a null object. More...
int | nonnull () const
| Return !null().
int | operator== (const Ref< A > &a) const
| A variety of ordering and equivalence operators are provided using the Identity class. More...
int | operator>= (const Ref< A > &a) const
int | operator<= (const Ref< A > &a) const
int | operator> (const Ref< A > &a) const
int | operator< (const Ref< A > &a) const
int | operator!= (const Ref< A > &a) const
int | compare (const Ref< SCVector > &a) const
| Compare two objects returning -1, 0, or 1. More...
void | clear ()
| Refer to the null object.
Ref< SCVector > & | operator= (const Ref< SCVector > &c)
| Assignment to c.
Ref< SCVector > & | operator= (const Ref< A > &c)
| Assignment to c.
Ref< SCVector > & | operator= (SCVector *cr)
| Assignment to cr.
Ref< SCVector > & | operator<< (const RefBase &a)
| Assignment to the object that a references using dynamic_cast.
Ref< SCVector > & | operator<< (RefCount *a)
| Assigns to the given base class pointer using dynamic_cast. More...
void | assign_pointer (SCVector *cr)
| Assignment to cr.
void | check_pointer () const
| Check the validity of the pointer.
void | ref_info (std::ostream &os) const
| Print information about the reference to os.
void | warn (const char *s) const
| Print a warning concerning the reference.
Public Member Functions inherited from sc::RefBase
void | require_nonnull () const
| Requires that a nonnull reference is held. More...

## Additional Inherited Members
Protected Member Functions inherited from sc::RefBase
void | warn (const char *msg) const
| Print a warning message.
void | warn_ref_to_stack () const
| Called when stack data is referenced.
void | warn_skip_stack_delete () const
| Called when the deletion of stack data is skipped.
void | warn_bad_ref_count () const
| Called when the reference count is corrupted.
void | ref_info (RefCount *p, std::ostream &os) const
| Print information about the reference.
void | ref_info (std::ostream &os) const
void | check_pointer () const
void | reference (RefCount *)
int | dereference (RefCount *)

## Detailed Description

The RefSCVector class is a smart pointer to an SCVector specialization.

## Constructor & Destructor Documentation

sc::RefSCVector::RefSCVector | ( |  | ) |

Initializes the vector pointer to 0.

The reference must be initialized before it is used.

sc::RefSCVector::RefSCVector | ( | const RefSCDimension & | dim,
|  | const Ref< SCMatrixKit > & |
| ) |  |

Create a vector with dimension dim.

The data values are undefined.

The documentation for this class was generated from the following file:

- matrix.h